#include <cstdio>
#include <cstdint>

#include "cifrasProduto.hpp"


int main(int argc, char *argv[]) {
  
  uint16_t d,a;
  char *msgClara,*msgCifrada, *chave;
  FILE *pfM, *pfC;
  
  
  if (argc<=3) { // valores de entrada insuficientes 
    printf("\nUtilização: ./encriptarproduto <chaveEncriptaçãoDe2ascii=2bytes> <nomeFicheiroMsgClara> <nomeFicheiroMsgCifrada>\n\n");
    return(1);
  }

  // chave dois caracteres (8bits) que são convertidos num uint16
  chave = argv[1];
  d = chave[0]; // 8 bits
  a = chave[1]; // 8 bits
  d = d<<8;     // deslocal 8 bits 8 posições para a esquerda
  d = d|a;      // combinar as duas parte num só bloco de 16bits

  // Ficheiro Mensagem Clara
  msgClara = argv[2];
  // Ficheiro Mensagem Cifrada
  msgCifrada = argv[3];

  if ((pfM = fopen(msgClara,"r")) == NULL) {
    printf("Não foi possível abrir o ficheiro %s\n",msgClara);
    return (2);
  }

  if ((pfC = fopen(msgCifrada,"w")) == NULL) {
    printf("Não foi possível abrir para escrita o ficheiro %s\n",msgCifrada);
    return (3);
  }

  CifrasProduto cifraProduto;
  
  cifraProduto.encriptarCifraProduto(pfM,pfC,d);

  fclose(pfM);
  fclose(pfC);

  return(0);
}
